﻿using UnityEngine;
using System.Collections;

public class ProtoToggle : MonoBehaviour {
	public int x;
	public int y;
	public BoardController board; 

	float springPos;
	float springVel;
	float springTarget;
	float springDamp = 5f;
	float springTension = 150;

	public Material neutral;
	public Material activeMat;
	public Material target;

	// Use this for initialization
	void Start () {
		board = GameObject.FindGameObjectWithTag("GameController").GetComponent<BoardController>();
	}
	
	// Update is called once per frame
	void Update () {
		if(board.grid[x,y]) springTarget = 0.5f;
		else springTarget = -0.5f;
		renderer.material = neutral;

		if(board.redX == x && board.redY == y) 
		{
			springTarget = -0.7f;
			renderer.material = activeMat;
		}
		if(board.blueX == x && board.blueY == y)
		{
			springTarget = 0.7f;
			renderer.material = activeMat;
		}
		if(board.targetX == x && board.targetY == y)
			renderer.material = target;

		springVel += (springTarget - springPos)*Time.deltaTime*springTension;
		springVel *= (1-springDamp*Time.deltaTime);
		springPos += springVel*Time.deltaTime;

		if(springPos > 0.7f) {springPos = 0.7f; springVel *= -0.5f;}
		if(springPos < -0.7f) {springPos = -0.7f; springVel *= -0.5f;}


		transform.localPosition = new Vector3(BoardController.g2b(x), springPos, BoardController.g2b(y));
	}
}
